//+------------------------------------------------------------------+
//|                                                FLI_DB_CANDLE.mq4 |
//|                   Copyright  2009, Francesco Marasco aka flinux |
//|                                       E-Mail: fmarasco@gmail.com |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators.                                         |
//|                                                                  |
//|   PayPal - fmarasco@gmail.com                                    |  
//+------------------------------------------------------------------+

#property copyright "Francesco Marasco"
#property link      "http://mt4forex.blogspot.com"

#property indicator_separate_window

extern bool  Show.Heading  = true;
extern int   yAxis         = 10;
extern int   Corner        = 0;
extern int   BarsToTest    = 24;
extern color TextColor     = White;
extern color HiLightColor  = Magenta;
extern int   SymbolWD      = 110;

int          tframe[]      = {1,5,15,30,60,240,1440,10080,43200};
string       tf[]          = {"M1","M5","M15","M30","H1","H4","D1","W1","MN","TOT"};
string       pairs[]       = {"EURUSD","EURJPY","EURCHF","EURGBP","EURAUD","EURCAD"};
int          tfnumber      = 9;
int          columns       = 10;
int          npairs        = 6;
bool         firsttime     = true;
string       TAG           = "FLI_DB_CANDLE";
int          xpos[10];
int          w, j, xposTAG;
color        theColor[10];
string       symbol;
int          period;
color        hdColor;
int          Semafor[10];
int          wnd;


int init()
{
   IndicatorShortName(TAG);
   wnd = WindowFind(TAG);   
   
   deinit();

   period       = Period() ;   
   symbol       = Symbol() ;

   if(Corner == 1 || Corner == 3)
   { 
      for( w = 0 ; w < columns ; w++) { xpos[w] = 15 + ((10 - w)*23) ; } 
      xposTAG = 270 ;
   } 
   else
   {
      for( w=0;w<columns;w++) { xpos[w] = w*23 + 50 ; }
      xposTAG = 10 ;
   }
  
   return(0);
} 

void ObDeleteObjectsByPrefix(string Prefix)
{
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
   {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) 
      { 
         i++; 
         continue;
      }
      ObjectDelete(ObjName);
   }
}
    
int deinit()
{
   ObDeleteObjectsByPrefix(TAG);  
   return(0);
}
  
int start()
{
   double bulls, bears;
   if(firsttime)
   {
      firsttime  =  false ;

      for (int z=0;z<npairs;z++)
      {      
         ObjectCreate(TAG+"HD1"+z,OBJ_LABEL,wnd,0,0,0,0);
         ObjectSet(TAG+"HD1"+z,OBJPROP_CORNER,Corner);
         ObjectSet(TAG+"HD1"+z,OBJPROP_XDISTANCE,xposTAG);
         ObjectSet(TAG+"HD1"+z,OBJPROP_YDISTANCE,yAxis+(30*(z+1)));
         ObjectSetText(TAG+"HD1"+z, pairs[z] ,8,"Tahoma",TextColor);
      }
      
      if(Show.Heading)
      {
         for( w = 0;w<columns;w++)
         {
            if(tframe[w]  ==  period) { hdColor  =  HiLightColor ; }
            else  { hdColor  =  TextColor ; }
      
            ObjectCreate(TAG+tf[w],OBJ_LABEL,wnd,0,0,0,0);
            ObjectSet(TAG+tf[w],OBJPROP_CORNER,Corner);
            ObjectSet(TAG+tf[w],OBJPROP_XDISTANCE,xpos[w]);
            ObjectSet(TAG+tf[w],OBJPROP_YDISTANCE,yAxis+15);
            ObjectSetText(TAG+tf[w],tf[w],8,"Tahoma",hdColor);                     
         }
      }   
   }

   for(z=0;z<npairs;z++)
   {
      for( j=0;j<columns ;j++)
      {
         if (ObjectFind(TAG+j) != 0)
         {
            ObjectCreate(TAG+j+"C"+z,OBJ_LABEL,wnd,0,0,0,0);        
            ObjectSet(TAG+j+"C"+z,OBJPROP_CORNER,Corner);
            ObjectSet(TAG+j+"C"+z,OBJPROP_XDISTANCE,xpos[j]);
            ObjectSet(TAG+j+"C"+z,OBJPROP_YDISTANCE,yAxis+(30*(z+1)));
            ObjectSetText(TAG+j+"C"+z,"00",8,"Tahoma",White);
         }
      }
   }

   for(z=0;z<npairs;z++)
   {
      bulls = 0;
      bears = 0;
      for(int x=0;x<tfnumber;x++)
      {
         if (iClose(pairs[z], tframe[x], 0)>iClose(pairs[z], tframe[x], 1))
         {
            bulls++;
            Semafor[x] = SymbolWD;
            theColor[x] = ForestGreen;
         }
         else
         if (iClose(pairs[z], tframe[x], 0)<iClose(pairs[z], tframe[x], 1))
         {
            bears++;
            Semafor[x] = SymbolWD;
            theColor[x] = FireBrick;
         }
         else
         if (iClose(pairs[z], tframe[x], 0)==iClose(pairs[z], tframe[x], 1))
         {
            Semafor[x] = SymbolWD;
            theColor[x] = Yellow;
         }

         for(int  y=0;y<(columns-1);y++)
         { 
            ObjectSetText(TAG+y+"C"+z,CharToStr(Semafor[y]),14,"WingDings",theColor[y]);
         }
         if (bulls>bears)
            ObjectSetText(TAG+(columns-1)+"C"+z,CharToStr(SymbolWD),14,"WingDings",ForestGreen);
         else
         if (bulls<bears)
            ObjectSetText(TAG+(columns-1)+"C"+z,CharToStr(SymbolWD),14,"WingDings",FireBrick);
         else
         if (bulls==bears)
            ObjectSetText(TAG+(columns-1)+"C"+z,CharToStr(SymbolWD),14,"WingDings",Yellow);
      } // for x
   } // for z
   return(0);
}

